#include <amxmodx>
#include <fakemeta>
#include <nvault>
#include <ColorChat>

new vaultId, maxPlayers;

new bool:isMuted[33][33];

public plugin_init() {
	register_plugin("Mute menu", "1.0", "d0naciak.pl");

	register_clcmd("say /mute", "cmd_MuteMenu");
	register_forward(FM_Voice_SetClientListening, "fw_SetClientListening")

	vaultId = nvault_open("Mute");
	nvault_prune(vaultId, 0, get_systime() - (86400 * 30));

	maxPlayers = get_maxplayers();
}

public plugin_end() {
	nvault_close(vaultId);
}

public client_authorized(id) {
	new name[2][64], vaultKey[128];

	get_user_name(id, name[0], charsmax(name[]));

	for(new i = 1; i <= maxPlayers; i++) {
		if(i == id || (!is_user_connected(i) && !is_user_connecting(i))) {
			isMuted[id][i] = isMuted[i][id] = false;
			continue;
		}

		get_user_name(i, name[1], charsmax(name[]));

		formatex(vaultKey, charsmax(vaultKey), "%s-%s", name[0], name[1]);
		if((isMuted[id][i] = bool:nvault_get(vaultId, vaultKey))) {
			nvault_touch(vaultId, vaultKey);
		}
		
		formatex(vaultKey, charsmax(vaultKey), "%s-%s", name[1], name[0]);
		if((isMuted[i][id] = bool:nvault_get(vaultId, vaultKey))) {
			nvault_touch(vaultId, vaultKey);
		}
	}
}

public cmd_MuteMenu(id) {
	new menuId = menu_create("Menu mutowania", "MuteMenu_Handler"), name[64], userId[16], itemName[128];

	for(new i = 1; i <= maxPlayers; i++) {
		if(i == id || !is_user_connected(i)) {
			continue;
		}

		num_to_str(get_user_userid(i), userId, charsmax(userId));
		get_user_name(i, name, charsmax(name));
		formatex(itemName, charsmax(itemName), "%s%s", name, isMuted[id][i] ? " \r[WYCISZONY]" : "");

		menu_additem(menuId, itemName, userId);
	}

	menu_setprop(menuId, MPROP_BACKNAME, "Powrot");
	menu_setprop(menuId, MPROP_NEXTNAME, "Dalej");
	menu_setprop(menuId, MPROP_EXITNAME, "Wyjscie");

	menu_display(id, menuId);
	return PLUGIN_HANDLED;
}

public MuteMenu_Handler(id, menuId, itemId) {
	switch(itemId) {
		case MENU_BACK, MENU_MORE: {
			return;
		}

		case 0..31: {
			new access, callBack, info[16], targetId;

			menu_item_getinfo(menuId, itemId, access, info, charsmax(info), _, _, callBack);
			targetId = find_player("k", str_to_num(info));

			if(!targetId) {
				ColorChat(id, GREEN, "[MUTE]^x01 Nie znaleziono gracza!");
			} else {
				new name[64], targetName[64], vaultKey[128];
				get_user_name(id, name, charsmax(name));
				get_user_name(id, targetName, charsmax(targetName));

				formatex(vaultKey, charsmax(vaultKey), "%s-%s", name, targetName);
				if((isMuted[id][targetId] = !isMuted[id][targetId])) {
					nvault_set(vaultId, vaultKey, "1");
					ColorChat(id, GREEN, "[MUTE]^x01 Wyciszenie gracza^x03 %s:^x04 WLACZONE", targetName);
				} else {
					nvault_remove(vaultId, vaultKey);
					ColorChat(id, GREEN, "[MUTE]^x01 Wyciszenie gracza^x03 %s:^x04 WYLACZONE", targetName);
				}
			}

			cmd_MuteMenu(id);
		}
	}

	menu_destroy(menuId);
}

public fw_SetClientListening(receiver, sender, listen) {
	if(isMuted[receiver][sender]) {
		engfunc(EngFunc_SetClientListening, receiver, sender, 0);
		return FMRES_SUPERCEDE;
	}

	return FMRES_IGNORED;
}


